#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/soundcard.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>

#include "core.h"

void coremain(void)
{
   int j;
   int fddsp;
   float oldsamplerate=0;

   // open sound device, 16 bit signed integers, stereo, with specified samplerate
   fddsp=open("/dev/dsp0",O_RDWR);
   if (fddsp<0) {
      fprintf(stderr,"Error opening /dev/dsp0 for read/write\n");
      fddsp=open("/dev/dsp0",O_RDONLY);
      if (fddsp<0) fprintf(stderr,"Error opening /dev/dsp0 for reading\n");
   }
   j=AFMT_S16_LE; if (ioctl(fddsp, SNDCTL_DSP_SETFMT, &j)<0) fprintf(stderr,"Can't set audio data format to 16 bit little-endian.\n");
   j=1; if (ioctl(fddsp, SNDCTL_DSP_STEREO, &j)<0) fprintf(stderr,"Can't set input to stereo.\n");

   while (1) {
      int nsamp;
      short int buf_in[256*2];
      short int buf_out[256*2];

      // if needed, change samplerate
      if (samplerate!=oldsamplerate) {
         j=(int)(0.5+samplerate); 
         if (ioctl(fddsp, SNDCTL_DSP_SPEED, &j)<0) {
            fprintf(stderr,"Can't set input sample rate to %f, setting it to %i instead.\n",samplerate,j);
            samplerate=j;
         }
         oldsamplerate=samplerate;
      }

      // try to read 256 samples, of 2 short (16 bit) ints each
      // nsamp is number of samples actually read
      nsamp=read(fddsp,buf_in,256*4)/4;
//      nsamp=read(fddsp,buf_in,256*4)/6;

      // process nsamp samples
      process_samples(buf_in,buf_out,nsamp);

      // write nsamp samples
      write(fddsp,buf_out,nsamp*4);
/*
      unsigned char buf[256*6*2];
      unsigned char *p;
      p=buf;
      int i;
      for (i=0;i<nsamp*2;i++) {
         *p++=(buf_out[i]/256);
         *p++=(buf_out[i]/256);
         *p++=(buf_out[i]/256);
      }
      write(fddsp,buf,nsamp*6);
*/
   }
}

